# -*- coding: utf-8 -*-

from itertools import chain
from operator import itemgetter

from kinder.core.dict.models import (WorkType,
                                     HealthNeed,
                                     HealthNeedEnumerate as HNE)


def get_all_day_work_types():

    work_types = WorkType.objects.all()
    all_day_types = [WorkType.ALLDAY]
    for work_type in work_types:
        code = work_type.code
        try:
            torn_code = code.split("-")
        except AttributeError:
            # Код может быть не заполнен
            continue

        map_code = torn_code[0]
        map_code = map_code.replace(",", ".")
        try:
            numeric_map_code = float(map_code)
        except ValueError:
            continue

        if numeric_map_code == 24:
            all_day_types.append(work_type.code)

    return all_day_types


def get_short_day_types():

    work_types = WorkType.objects.all()
    short_types = [WorkType.SHORT]
    for work_type in work_types:
        code = work_type.code
        try:
            torn_code = code.split("-")
        except AttributeError:
            # Код может быть не заполнен
            continue

        map_code = torn_code[0]
        map_code = map_code.replace(",", ".")
        try:
            numeric_map_code = float(map_code)
        except ValueError:
            continue

        if 1 <= numeric_map_code < 8:
            short_types.append(work_type.code)

    return short_types


def get_all_health_need():
    return dict(HealthNeed.objects.values_list('id', 'code'))


def get_need_helth_id(code):
    result = []
    health_needs = get_all_health_need()
    for hn in health_needs:
        if health_needs[hn] in code:
            result.append(hn)
    return result


health_need_22_1 = get_need_helth_id([HNE.DEAFNESS, HNE.HARDOFHEARTING])
health_need_22_2 = get_need_helth_id([HNE.SPEACH, HNE.PHONETICS])
health_need_22_3 = get_need_helth_id([HNE.BLINDNESS, HNE.AMAUROSIS])
health_need_22_4 = get_need_helth_id([HNE.BACKLIGHT, HNE.BACKHARD])
health_need_22_5 = get_need_helth_id([HNE.BACK])
health_need_22_6 = get_need_helth_id([HNE.DISABLEMENT])
health_need_22_7 = get_need_helth_id([HNE.INVALIDITY])
not_health_need = get_need_helth_id([HNE.NOT])
# id всех ОВЗ, кроме значения "Нет", равносильно наличию ОВЗ.
has_health_need = get_need_helth_id(set(HNE.values.keys()) - set([HNE.NOT]))

# Список id всех предыдущих элементов
health_need_22_x = list(chain.from_iterable([
    health_need_22_1,
    health_need_22_2,
    health_need_22_3,
    health_need_22_4,
    health_need_22_5,
    health_need_22_6,
    health_need_22_7,
    not_health_need
]))


# Все остальные значения
def health_need_22_8():
    return tuple(
        set(get_all_health_need().keys()) - set(health_need_22_x))
